<?php

namespace Teknisa\MAN\Services;

use Teknisa\MAN\Utilities\Query;

class ProdLoja {

	protected $entityManager;

	public function __construct(\Doctrine\ORM\EntityManager $entityManager)  {
		$this->entityManager = $entityManager;
	}
	
    public function findProductsForAdd($NRORG, $CDFILIAL, $CDLOJA, $CDNVPRODUTO) {
		$params = array(
			':NRORG' => $NRORG,
			':CDFILIAL' => $CDFILIAL,
			':CDLOJA' => $CDLOJA,
			':CDNVPRODUTO' => $CDNVPRODUTO
		);
		
		return $this->entityManager->getConnection()->fetchAll(Query::PRODUCTS_FOR_ADD, $params);
    }

	public function findProductsByPrinter($CDFILIAL, $CDLOJA, $NRSEQIMPRLOJA, $NRORG ) {
		$params = array(
			':NRORG' => $NRORG,
			':CDFILIAL' => $CDFILIAL,
			':CDLOJA' => $CDLOJA,
			':NRSEQIMPRLOJA' => $NRSEQIMPRLOJA
		);
		
		return $this->entityManager->getConnection()->fetchAll(Query::COUNT_PRODUCTS_BY_PRINTER_IN_A_STORE, $params);
	}

    public function getProdutosLoja($CDFILIAL, $CDLOJA, $PRODINICIAL, $PRODFINAL, $NRORG) {
        $parametros = array(
            'CDFILIAL' => $CDFILIAL,
            'CDLOJA'   => $CDLOJA,
            'PRODINICIAL' => $PRODINICIAL,
            'PRODFINAL'   => $PRODFINAL,
            'NRORG' => $NRORG
        );
        return $this->entityManager->getConnection()->fetchAll(Util\Query::GET_PRODUTO_LOJA, $parametros);
    }
    
	public function getPrinters ($CDFILIAL, $CDLOJA, $NRORG) {
		$params = array(
			':CDFILIAL' => $CDFILIAL,
			':NRORG'    => $NRORG,
			':CDLOJA'   => $CDLOJA
		);

		return $this->entityManager->getConnection()->fetchAll(Query::GET_IMPRESSORAS, $params);
	}

	public function getProductsForAdd ($CDFILIAL, $CDLOJA, $NRORG) {
		$params = array(
			':CDFILIAL' => $CDFILIAL,
			':NRORG'    => $NRORG,
			':CDLOJA'   => $CDLOJA
		);

		return $this->entityManager->getConnection()->fetchAll(Query::GET_PRODUCTS_FOR_ADD, $params);
	}

	public function getDepartments ($NRORG) {
		$params = array(
			':NRORG' => $NRORG	
		);
		
		return $this->entityManager->getConnection()->fetchAll(Query::GET_SETORES, $params);
	}
	
	public function saveProductsArray($row) {
		$params = array(
			':CDPRODINICIAL'=> $row['CDPRODINICIAL'],
			':NIVELINICIAL' => $row['NIVELINICIAL'],
			':CDPRODFINAL'	=> $row['CDPRODFINAL'],
			':CDFILIAL' 	=> $row['CDFILIAL'],
			':CDLOJA'		=> $row['CDLOJA'],
			':NRORG'		=> $row['NRORG'],
		);
		
		if(is_array($row['PRODUTOS'])){
			foreach ($row['PRODUTOS'] as $prod){
				$products[] = array('CDPRODUTO'=>$prod);
			}
		}else{
			$products = $this->entityManager->getConnection()->fetchAll(self::GET_AVAIBLE_PRODUCTS, $params);
		}
		
		if(count($products)){
			foreach ($products as $product) {
				$params = array(
					':CDFILIAL'      => $row['CDFILIAL'],
					':NRORG'         => $row['NRORG'],
					':CDOPERINCLUSAO'=> $row['CDOPERADOR'],
					':DTINCLUSAO'    => $row['DTATU'],
					':CDLOJA'        => $row['CDLOJA'],
					':CDPRODUTO'     => $product['CDPRODUTO'],
					':IDIMPCANITEM'  => $row['IDIMPCANITEM'],
					':CDSETOR'       => $row['CDSETOR'],
					':NRSEQIMPRPROD' => $row['NRSEQIMPRPROD'],
					':NRSEQIMPRPROD2'=> $row['NRSEQIMPRPROD2'],
					':NRSEQIMPRPUXA' => $row['NRSEQIMPRPUXA']
				);
				
				
				if(!$this->checkCdProdutoIsNotNull($params)){
					$this->entityManager->getConnection()->executeQuery(self::INSERT_PRODLOJA, $params);
				}else{
					$this->entityManager->getConnection()->executeQuery(self::UPDATE_PRODLOJA, $params);
				}
			}
		}
	}
	

	public function updateProduct ($row) {
		$params = array(
			':IDIMPCANITEM'   => $row['IDIMPCANITEM'],
			':NRORG'          => $row['NRORG'],
			':NRORGULTATU'    => $row['DTATU'],
			':DTULTATU'       => $row['DTATU'],
			':CDOPERULTATU'   => $row['CDOPERADOR'],
			':CDSETOR'        => $row['CDSETOR'],
			':NRSEQIMPRPROD'  => $row['NRSEQIMPRPROD'],
			':NRSEQIMPRPROD2' => $row['NRSEQIMPRPROD2'],
			':NRSEQIMPRPUXA'  => $row['NRSEQIMPRPUXA'],
			':CDFILIAL'       => $row['CDFILIAL'],
			':CDLOJA'         => $row['CDLOJA'],
			':CDPRODUTO'      => $row['CDPRODUTO']
		);
		
		return $this->entityManager->getConnection()->executeQuery(self::UPDATE_PRODLOJA, $params);
		
	}

	public function insertProduct ($CDFILIAL, $CDLOJA, $CDPRODUTO, $IDIMPCANITEM,
									$CDSETOR, $NRSEQIMPRPROD, $NRSEQIMPRPUXA, $NRORG, $DTINCLUSAO, $CDOPERINCLUSAO) {
		$params = array(
			':CDFILIAL'      => $CDFILIAL,
			':NRORG'         => $NRORG,
			':CDOPERINCLUSAO'=> $CDOPERINCLUSAO,
			':DTINCLUSAO'    => $DTINCLUSAO,
			':CDLOJA'        => $CDLOJA,
			':CDPRODUTO'     => $CDPRODUTO,
			':IDIMPCANITEM'  => $IDIMPCANITEM,
			':CDSETOR'       => $CDSETOR,
			':NRSEQIMPRPROD' => $NRSEQIMPRPROD,
			':NRSEQIMPRPUXA' => $NRSEQIMPRPUXA
		);

		return $this->entityManager->getConnection()->executeQuery(Query::INSERT_PRODLOJA, $params);
	}

	public function deleteProduct ($CDFILIAL, $CDLOJA, $CDPRODUTO, $NRORG) {
		$params = array(
			':CDFILIAL'  => $CDFILIAL,
			':NRORG'     => $NRORG,
			':CDLOJA'    => $CDLOJA,
			':CDPRODUTO' => $CDPRODUTO
		);

		return $this->entityManager->getConnection()->executeQuery(Query::REMOVE_PRODLOJA, $params);
	}

	public function getAreas ($CDFILIAL, $NRCONFTELA, $NRORG) {
		$params = array(
			':CDFILIAL'   => $CDFILIAL,
			':NRORG'      => $NRORG,
			':NRCONFTELA' => $NRCONFTELA
		);
		return $this->entityManager->getConnection()->fetchAll(Query::GET_AMBIENTES, $params);
	}

	public function getProdAreas ($CDFILIAL, $CDLOJA, $CDPRODUTO, $NRORG) {
		$params = array(
			':CDFILIAL'   => $CDFILIAL,
			':NRORG'      => $NRORG,
			':CDLOJA'     => $CDLOJA,
			':CDPRODUTO'  => $CDPRODUTO
		);

		return $this->entityManager->getConnection()->fetchAll(Query::GET_PRODAMBIENTES, $params);
	}

	public function getProdAreaDuplicate ($CDFILIAL, $CDLOJA, $CDPRODUTO, $NRCONFTELA, $CDAMBIENTE, $NRSEQIMPRLOJA, $NRORG) {
		$params = array(
			':CDFILIAL'      => $CDFILIAL,
			':NRORG'         => $NRORG,
			':CDLOJA'        => $CDLOJA,
			':CDPRODUTO'     => $CDPRODUTO,
			':NRCONFTELA'    => $NRCONFTELA,
			':CDAMBIENTE'    => $CDAMBIENTE,
			':NRSEQIMPRLOJA' => $NRSEQIMPRLOJA
		);

		return $this->entityManager->getConnection()->fetchAll(Query::GET_PRODAMBIENTE_DUPLICADO, $params);
	}

	public function getConfScreen ($CDFILIAL, $CDLOJA, $NRORG) {
		$params = array(
			':CDFILIAL' => $CDFILIAL,
			':NRORG'    => $NRORG,
			':CDLOJA'   => $CDLOJA
		);

		return $this->entityManager->getConnection()->fetchAll(Query::GET_CONFTELA, $params);
	}

	public function insertProdArea ($CDFILIAL, $CDLOJA, $CDPRODUTO, $NRPRODAMBIENTE, $NRCONFTELA,
									$CDAMBIENTE, $NRSEQIMPRLOJA, $NRORG) {
		$params = array(
			':CDFILIAL'       => $CDFILIAL,
			':NRORG'          => $NRORG,
			':CDLOJA'         => $CDLOJA,
			':CDPRODUTO'      => $CDPRODUTO,
			':NRPRODAMBIENTE' => $NRPRODAMBIENTE,
			':NRCONFTELA'     => $NRCONFTELA,
			':CDAMBIENTE'     => $CDAMBIENTE,
			':NRSEQIMPRLOJA'  => $NRSEQIMPRLOJA
		);

		return $this->entityManager->getConnection()->executeQuery(Query::INSERT_PRODAMBIENTE, $params);
	}

	public function deleteProdArea ($CDFILIAL, $CDLOJA, $CDPRODUTO, $NRPRODAMBIENTE, $NRORG) {
		$params = array(
			':CDFILIAL'       => $CDFILIAL,
			':NRORG'          => $NRORG,
			':CDLOJA'         => $CDLOJA,
			':CDPRODUTO'      => $CDPRODUTO,
			':NRPRODAMBIENTE' => $NRPRODAMBIENTE
		);

		return $this->entityManager->getConnection()->executeQuery(Query::DELETE_PRODAMBIENTE, $params);
	}

	public function updateProdArea ($NRCONFTELA, $CDAMBIENTE, $NRSEQIMPRLOJA, $CDFILIAL,
									$CDLOJA, $CDPRODUTO, $NRPRODAMBIENTE, $NRORG) {
		$params = array(
			':NRCONFTELA'     => $NRCONFTELA,
			':NRORG'          => $NRORG,
			':CDAMBIENTE'     => $CDAMBIENTE,
			':NRSEQIMPRLOJA'  => $NRSEQIMPRLOJA,
			':CDFILIAL'       => $CDFILIAL,
			':CDLOJA'         => $CDLOJA,
			':CDPRODUTO'      => $CDPRODUTO,
			':NRPRODAMBIENTE' => $NRPRODAMBIENTE
		);

		return $this->entityManager->getConnection()->executeQuery(Query::UPDATE_PRODAMBIENTE, $params);
	}

	public function beginTransaction () {
		$this->entityManager->getConnection()->beginTransaction();
	}

	public function commit() {
		$this->entityManager->getConnection()->commit();
	}

	public function rollBack() {
		$this->entityManager->getConnection()->rollBack();
	}
	
	public function cadastroAutomaticoProdutosParaLojas($row){
		$lojas = $row['CDLOJA'];
		if(count($lojas)){
			foreach ($lojas as $cdloja) {
				if(isset($row['PRODUTOS']) && is_array($row['PRODUTOS'])){
					foreach ($row['PRODUTOS'] as $prod){
						$products[] = array('CDPRODUTO'=>$prod);
					}
				}else{
					$params = array(
						':CDPRODINICIAL'=> $row['CDPRODINICIAL'],
						':NIVELINICIAL' => $row['NIVELINICIAL'],
						':CDPRODFINAL'	=> $row['CDPRODFINAL'],
						':CDFILIAL' 	=> $row['CDFILIAL'],
						':CDLOJA'		=> $cdloja,
						':NRORG'		=> $row['NRORG'],
					);
					$products = $this->entityManager->getConnection()->fetchAll(self::GET_AVAIBLE_PRODUCTS, $params);
				}
				
				if(count($products)){
					foreach ($products as $product) {
					
						$params = array(
							':CDFILIAL'      => $row['CDFILIAL'],
							':NRORG'         => $row['NRORG'],
							':CDOPERINCLUSAO'=> $row['CDOPERADOR'],
							':DTINCLUSAO'    => $row['DTATU'],
							':CDLOJA'        => $cdloja,
							':CDPRODUTO'     => $product['CDPRODUTO'],
							':IDIMPCANITEM'  => $row['IDIMPCANITEM'],
							':CDSETOR'       => null,
							':NRSEQIMPRPROD' => isset($row['NRSEQIMPRPROD']) ? $row['NRSEQIMPRPROD'] : null,
							':NRSEQIMPRPROD2'=> isset($row['NRSEQIMPRPROD2']) ? $row['NRSEQIMPRPROD2'] : null,
							':NRSEQIMPRPUXA' => isset($row['NRSEQIMPRPUXA']) ? $row['NRSEQIMPRPUXA'] : null
						);
						if(!$this->checkCdProdutoIsNotNull($params)){
							$this->entityManager->getConnection()->executeQuery(self::INSERT_PRODLOJA, $params);
						}else{
							$this->entityManager->getConnection()->executeQuery(self::UPDATE_PRODLOJA, $params);
						}
					}
				}
			}
		}
	}
	
	private function checkCdProdutoIsNotNull ($params){
		return count($this->entityManager->getConnection()->fetchAll(self::CHECK_CDPRODUTO, $params)) > 0;
	}
	
	public function cadastroAutomaticoProdutosNivel($row){
		$lojas = $row['CDLOJA'];
		if(count($lojas)){
			foreach ($lojas as $cdloja) {
				
				$params = array(
					':CDNVPRODUTO'   => $row['NIVELINICIAL'],
					':CDFILIAL'      => $row['CDFILIAL'],
					':CDLOJA'	     => $cdloja,
					':NRORG'	     => $row['NRORG'],
					':CDPRODEXCECAO' => isset($row['CDPRODUTOEXCE']) ? $row['CDPRODUTOEXCE'] ? $row['CDPRODUTOEXCE'] : 'N' : 'N',
				);
				
				$products = $this->entityManager->getConnection()->fetchAll(self::GET_PRODUTO_NIVEL, $params);
				
				if(count($products)){
					foreach ($products as $product) {
						
						$params = array(
							':CDPRODUTO' => $product['CDPRODUTO'],
							':CDFILIAL'  => $row['CDFILIAL'],
							':CDLOJA'	 => $cdloja,
							':NRORG'	 => $row['NRORG']
						);
						
						$prodlojanivel = $this->entityManager->getConnection()->fetchAll(self::GET_PRODLOJANIVEL, $params);
						
						$params = array(
							':CDFILIAL'      => $row['CDFILIAL'],
							':CDLOJA'        => $cdloja,
							':CDPRODUTO'     => $product['CDPRODUTO'],
							':NRSEQIMPRPROD' => isset($row['NRSEQIMPRPROD']) ? $row['NRSEQIMPRPROD'] : null,
							':NRSEQIMPRPROD2'=> isset($row['NRSEQIMPRPROD2']) ? $row['NRSEQIMPRPROD2'] : null,
							':NRSEQIMPRPUXA' => isset($row['NRSEQIMPRPUXA']) ? $row['NRSEQIMPRPUXA'] : null,
							':IDIMPCANITEM'  => $row['IDIMPCANITEM'],
							':CDSETOR'       => isset($row['CDSETOR']) ? $row['CDSETOR'] : null,
							':CDPRODEXCECAO' => isset($row['CDPRODUTOEXCE']) ? $row['CDPRODUTOEXCE'] : null,
							':NRORG'         => $row['NRORG']
						);
						
						if(count($prodlojanivel))
							 $this->entityManager->getConnection()->executeQuery(self::UPDATE_PRODLOJANIVEL, $params);
						else $this->entityManager->getConnection()->executeQuery(self::INSERT_PRODLOJANIVEL, $params);
					}
				}
				
			}
		}
	}
	
	const CHECK_CDPRODUTO = "
		SELECT CDPRODUTO
		FROM PRODLOJA
		WHERE CDFILIAL = :CDFILIAL
		AND CDLOJA     = :CDLOJA
		AND NRORG      = :NRORG
		AND CDPRODUTO  = :CDPRODUTO
	";
	
	const GET_AVAIBLE_PRODUCTS = "
		SELECT P.CDPRODUTO, CDARVPROD
		  FROM PRODUTO P
		  LEFT JOIN PRODFILI PF
		    ON (PF.CDPRODUTO = P.CDPRODUTO)
		   AND (PF.CDFILIAL = :CDFILIAL)
		   AND (PF.NRORG    = :NRORG)
		  LEFT JOIN PRODLOJA L
		    ON L.CDPRODUTO    = P.CDPRODUTO
		   AND L.NRORG       = P.NRORG
		   AND L.CDLOJA      = :CDLOJA
		 WHERE P.NRORG     = :NRORG
		   AND P.CDARVPROD BETWEEN :CDPRODINICIAL AND :CDPRODFINAL
		   AND P.CDNVPRODUTO = (SELECT MAX(CDNVPRODUTO) FROM PRODUTO WHERE NRORG = :NRORG )
		 ORDER BY P.CDARVPROD
	";
	
	const INSERT_PRODLOJA = "
        INSERT INTO PRODLOJA
          (CDFILIAL, CDLOJA, CDPRODUTO, IDIMPCANITEM, CDSETOR, NRSEQIMPRPROD, NRSEQIMPRPROD2,
            NRSEQIMPRPUXA, CDPORIMPPROD, CDTIPIMPPROD, NRORG)
        VALUES
          (:CDFILIAL, :CDLOJA, :CDPRODUTO, :IDIMPCANITEM, :CDSETOR, :NRSEQIMPRPROD, :NRSEQIMPRPROD2,
            :NRSEQIMPRPUXA, ' ', '0', :NRORG)
    ";
    
    const UPDATE_PRODLOJA = "
        UPDATE PRODLOJA
           SET IDIMPCANITEM = :IDIMPCANITEM, 
               CDSETOR = :CDSETOR, 
               NRSEQIMPRPROD = :NRSEQIMPRPROD,
               NRSEQIMPRPROD2 = :NRSEQIMPRPROD2,
                 NRSEQIMPRPUXA = :NRSEQIMPRPUXA, 
                 DTULTATUPLOJ = SYSDATE
         WHERE CDFILIAL  = :CDFILIAL
           AND CDLOJA    = :CDLOJA
           AND CDPRODUTO = :CDPRODUTO
           AND NRORG     = :NRORG
    ";
    
    const GET_PRODUTO_NIVEL = "
		SELECT P.CDPRODUTO
		  FROM PRODUTO P
		  LEFT JOIN PRODFILI PF
		    ON (PF.CDPRODUTO = P.CDPRODUTO)
		   AND (PF.CDFILIAL  = :CDFILIAL)
		   AND (PF.NRORG     = :NRORG)
		  LEFT JOIN PRODLOJA L
		    ON L.CDPRODUTO   = P.CDPRODUTO
		   AND L.NRORG       = P.NRORG
		   AND L.CDLOJA      = :CDLOJA
		 WHERE P.NRORG       = :NRORG
		   AND P.CDNVPRODUTO <> (SELECT MAX(CDNVPRODUTO) FROM PRODUTO WHERE NRORG = :NRORG )
		   AND (SUBSTR(P.CDARVPROD,0,LENGTH(:CDNVPRODUTO)) = :CDNVPRODUTO)
           AND (P.CDARVPROD NOT LIKE :CDPRODEXCECAO||'%' OR :CDPRODEXCECAO = 'N')
		 ORDER BY P.CDARVPROD
	";
    
    const GET_PRODLOJANIVEL = "
		SELECT CDPRODUTO, CDFILIAL, CDLOJA, NRORG
		  FROM PRODLOJANIVEL
		 WHERE NRORG     = :NRORG
		   AND CDFILIAL  = :CDFILIAL
		   AND CDLOJA    = :CDLOJA
		   AND CDPRODUTO = :CDPRODUTO
	";
    
    const INSERT_PRODLOJANIVEL = "
		INSERT INTO PRODLOJANIVEL (
		    CDFILIAL, CDLOJA, CDPRODUTO, NRSEQIMPRPROD, NRSEQIMPRPROD2, NRSEQIMPRPUXA, IDIMPCANITEM, CDSETOR, CDPRODEXCECAO, NRORG
		)VALUES(
		    :CDFILIAL, :CDLOJA, :CDPRODUTO, :NRSEQIMPRPROD, :NRSEQIMPRPROD2, :NRSEQIMPRPUXA, :IDIMPCANITEM, :CDSETOR, :CDPRODEXCECAO, :NRORG
		)
	";
	
	const UPDATE_PRODLOJANIVEL = "
		UPDATE PRODLOJANIVEL SET NRSEQIMPRPROD = :NRSEQIMPRPROD, NRSEQIMPRPROD2 = :NRSEQIMPRPROD2, NRSEQIMPRPUXA = :NRSEQIMPRPUXA, IDIMPCANITEM = :IDIMPCANITEM, CDSETOR = :CDSETOR, CDPRODEXCECAO = :CDPRODEXCECAO 
		 WHERE NRORG     = :NRORG
		   AND CDFILIAL  = :CDFILIAL
		   AND CDLOJA    = :CDLOJA
		   AND CDPRODUTO = :CDPRODUTO
	";
}